%all images and filters must be square.
%filter size must be odd.

clear
close all
clc

support=16;

filter=createfilter('gauss',15,3);
im=(double(imread('Orig.png'))/255); %the image (b) in the pdf is "Orig.png"
if size(im, 1) ~= size(im, 2) %resize to square image
    as = max(size(im, 1),size(im, 2));
    if mod(as, 4) ~= 0
        as = ceil(as/4)*4;
    end
    imResize = zeros(as, as, 3);
    imResize(1:size(im, 1),1:size(im, 2), :) = im;
end

for pp = 2 %red, green, and blue channels 
    imm = imResize(:, :, pp);
    
    blurred=imm;
    [rect_im, mask]=bluredges(blurred,filter);
    
    num_iter=5000;
    
    angles=extractangles(rect_im,filter);
    f1=fft2(rect_im);
    f1=abs(f1(1,1));
    
    x=zeros(size(rect_im));
    x(1, 1)=100;
    
    for ii=1:num_iter
        fx = fft2(x);
        %replace fourier transform phase
        fx = abs(fx).*exp(1i*angles);
        fx(1,1)=f1;
        x = ifft2(fx);
        x = real(mask.*x);
        x(x<0)=0;
        x(x>1)=1;
        
        if ii>num_iter-10 %imposing TV constraint
            x = PESC(x);
        end
        ii
    end
    
    cut(:,:, pp)=extractmiddle(x);
end

%desplaying image
filename='Orig.png';
immm=readimage(filename,'color');
[xx, yy, zz] = size(immm);
cutt(1:xx, 1:yy, 2) = cut(1:xx, 1:yy, 2);
cutt(1:xx, 1:yy, 1) = immm(:, :, 1);
cutt(1:xx, 1:yy, 3) = immm(:, :, 3);

figure;
subplot(1,2,1)
imshow(immm);
title('Original blury image')

subplot(1,2,2)
imshow(cutt);
title('Deconvolved image')